ParagraphView (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing.text, class: ParagraphView
Keywords: javax.swing.text.ParagraphView class

# Class ParagraphView

java.lang.Object
javax.swing.text.View
javax.swing.text.CompositeView
javax.swing.text.BoxView
javax.swing.text.FlowView
javax.swing.text.ParagraphView

All Implemented Interfaces:
  `SwingConstants, TabExpander`

Direct Known Subclasses:
  `ParagraphView`

public class ParagraphView extends FlowView implements TabExpander
View of a simple line-wrapping paragraph that supports multiple fonts, colors, components, icons, etc. It is basically a vertical box with a margin around it. The contents of the box are a bunch of rows which are special horizontal boxes. This view creates a collection of views that represent the child elements of the paragraph element. Each of these views are placed into a row directly if they will fit, otherwise the `breakView` method is called to try and carve the view into pieces that fit.

See Also:
  - `View`

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class FlowView

  `FlowView.FlowStrategy`
  Modifier and Type
  Class
  Description
  `static class`
  `FlowView.FlowStrategy`
  Strategy for maintaining the physical form of the flow.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected int`
  `firstLineIndent`
  Indentation for the first line, from the left inset.

  ### Fields declared in class FlowView

  `layoutPool, layoutSpan, strategy`
  Modifier and Type
  Field
  Description
  `protected View`
  `layoutPool`
  These are the views that represent the child elements of the element this view represents (The logical view to translate to a physical view).
  `protected int`
  `layoutSpan`
  Default constraint against which the flow is created against.
  `protected FlowView.FlowStrategy`
  `strategy`
  The behavior for keeping the flow updated.

  ### Fields declared in class View

  `BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`
  Modifier and Type
  Field
  Description
  `static final int`
  `BadBreakWeight`
  The weight to indicate a view is a bad break opportunity for the purpose of formatting.
  `static final int`
  `ExcellentBreakWeight`
  The weight to indicate a view supports breaking, and this represents a very attractive place to break.
  `static final int`
  `ForcedBreakWeight`
  The weight to indicate a view supports breaking, and must be broken to be represented properly when placed in a view that formats its children by breaking them.
  `static final int`
  `GoodBreakWeight`
  The weight to indicate a view supports breaking, but better opportunities probably exist.
  `static final int`
  `X_AXIS`
  Axis for format/break operations.
  `static final int`
  `Y_AXIS`
  Axis for format/break operations.

  ### Fields declared in interface SwingConstants

  `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`
  Modifier and Type
  Field
  Description
  `static final int`
  `BOTTOM`
  Box-orientation constant used to specify the bottom of a box.
  `static final int`
  `CENTER`
  The central position in an area.
  `static final int`
  `EAST`
  Compass-direction east (right).
  `static final int`
  `HORIZONTAL`
  Horizontal orientation.
  `static final int`
  `LEADING`
  Identifies the leading edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `LEFT`
  Box-orientation constant used to specify the left side of a box.
  `static final int`
  `NEXT`
  Identifies the next direction in a sequence.
  `static final int`
  `NORTH`
  Compass-direction North (up).
  `static final int`
  `NORTH_EAST`
  Compass-direction north-east (upper right).
  `static final int`
  `NORTH_WEST`
  Compass-direction north west (upper left).
  `static final int`
  `PREVIOUS`
  Identifies the previous direction in a sequence.
  `static final int`
  `RIGHT`
  Box-orientation constant used to specify the right side of a box.
  `static final int`
  `SOUTH`
  Compass-direction south (down).
  `static final int`
  `SOUTH_EAST`
  Compass-direction south-east (lower right).
  `static final int`
  `SOUTH_WEST`
  Compass-direction south-west (lower left).
  `static final int`
  `TOP`
  Box-orientation constant used to specify the top of a box.
  `static final int`
  `TRAILING`
  Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `VERTICAL`
  Vertical orientation.
  `static final int`
  `WEST`
  Compass-direction west (left).

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ParagraphView(Element elem)`
  Constructs a `ParagraphView` for the given element.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `View`
  `breakView(int axis, float len, Shape a)`
  Breaks this view on the given axis at the given length.
  `protected SizeRequirements`
  `calculateMinorAxisRequirements(int axis, SizeRequirements r)`
  Calculate the needs for the paragraph along the minor axis.
  `void`
  `changedUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification from the document that attributes were changed in a location that this view is responsible for.
  `protected View`
  `createRow()`
  Create a `View` that should be used to hold a a row's worth of children in a flow.
  `protected int`
  `findOffsetToCharactersInString(char[] string, int start)`
  Finds the next character in the document with a character in `string`, starting at offset `start`.
  `protected boolean`
  `flipEastAndWestAtEnds(int position, Position.Bias bias)`
  Determines in which direction the next view lays.
  `float`
  `getAlignment(int axis)`
  Determines the desired alignment for this view along an axis.
  `int`
  `getBreakWeight(int axis, float len)`
  Gets the break weight for a given location.
  `protected int`
  `getClosestPositionTo(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet, int rowIndex, int x)`
  Returns the closest model position to `x`.
  `int`
  `getFlowSpan(int index)`
  Fetches the constraining span to flow against for the given child index.
  `int`
  `getFlowStart(int index)`
  Fetches the location along the flow axis that the flow span will start at.
  `protected View`
  `getLayoutView(int index)`
  Returns the view at a given `index`.
  `protected int`
  `getLayoutViewCount()`
  Returns the number of views that this view is responsible for.
  `protected int`
  `getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Returns the next visual position for the cursor, in either the east or west direction.
  `protected float`
  `getPartialSize(int startOffset, int endOffset)`
  Returns the size used by the views between `startOffset` and `endOffset`.
  `protected float`
  `getTabBase()`
  Returns where the tabs are calculated from.
  `protected TabSet`
  `getTabSet()`
  Gets the `Tabset` to be used in calculating tabs.
  `float`
  `nextTabStop(float x, int tabOffset)`
  Returns the next tab stop position given a reference position.
  `void`
  `paint(Graphics g, Shape a)`
  Renders using the given rendering surface and area on that surface.
  `protected void`
  `setFirstLineIndent(float fi)`
  Sets the indent on the first line.
  `protected void`
  `setJustification(int j)`
  Sets the type of justification.
  `protected void`
  `setLineSpacing(float ls)`
  Sets the line spacing.
  `protected void`
  `setPropertiesFromAttributes()`
  Set the cached properties from the attributes.

  ### Methods declared in class FlowView

  `getFlowAxis, getViewIndexAtPosition, insertUpdate, layout, loadChildren, removeUpdate`
  Modifier and Type
  Method
  Description
  `int`
  `getFlowAxis()`
  Fetches the axis along which views should be flowed.
  `protected int`
  `getViewIndexAtPosition(int pos)`
  Fetches the child view index representing the given position in the model.
  `void`
  `insertUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification that something was inserted into the document in a location that this view is responsible for.
  `protected void`
  `layout(int width, int height)`
  Lays out the children.
  `protected void`
  `loadChildren(ViewFactory f)`
  Loads all of the children to initialize the view.
  `void`
  `removeUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification that something was removed from the document in a location that this view is responsible for.

  ### Methods declared in class BoxView

  `baselineLayout, baselineRequirements, calculateMajorAxisRequirements, childAllocation, forwardUpdate, getAxis, getChildAllocation, getHeight, getMaximumSpan, getMinimumSpan, getOffset, getPreferredSpan, getResizeWeight, getSpan, getViewAtPoint, getWidth, isAfter, isAllocationValid, isBefore, isLayoutValid, layoutChanged, layoutMajorAxis, layoutMinorAxis, modelToView, paintChild, preferenceChanged, replace, setAxis, setSize, viewToModel`
  Modifier and Type
  Method
  Description
  `protected void`
  `baselineLayout(int targetSpan, int axis, int[] offsets, int[] spans)`
  Computes the location and extent of each child view in this `BoxView` given the `targetSpan`, which is the width (or height) of the region we have to work with.
  `protected SizeRequirements`
  `baselineRequirements(int axis, SizeRequirements r)`
  Calculates the size requirements for this `BoxView` by examining the size of each child view.
  `protected SizeRequirements`
  `calculateMajorAxisRequirements(int axis, SizeRequirements r)`
  Calculates the size requirements for the major axis `axis`.
  `protected void`
  `childAllocation(int index, Rectangle alloc)`
  Allocates a region for a child view.
  `protected void`
  `forwardUpdate(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the given `DocumentEvent` to the child views that need to be notified of the change to the model.
  `int`
  `getAxis()`
  Fetches the tile axis property.
  `Shape`
  `getChildAllocation(int index, Shape a)`
  Fetches the allocation for the given child view.
  `int`
  `getHeight()`
  Returns the current height of the box.
  `float`
  `getMaximumSpan(int axis)`
  Determines the maximum span for this view along an axis.
  `float`
  `getMinimumSpan(int axis)`
  Determines the minimum span for this view along an axis.
  `protected int`
  `getOffset(int axis, int childIndex)`
  Fetches the offset of a particular child's current layout.
  `float`
  `getPreferredSpan(int axis)`
  Determines the preferred span for this view along an axis.
  `int`
  `getResizeWeight(int axis)`
  Gets the resize weight.
  `protected int`
  `getSpan(int axis, int childIndex)`
  Fetches the span of a particular child's current layout.
  `protected View`
  `getViewAtPoint(int x, int y, Rectangle alloc)`
  Fetches the child view at the given coordinates.
  `int`
  `getWidth()`
  Returns the current width of the box.
  `protected boolean`
  `isAfter(int x, int y, Rectangle innerAlloc)`
  Determines if a point falls after an allocated region.
  `protected boolean`
  `isAllocationValid()`
  Are the allocations for the children still valid?
  `protected boolean`
  `isBefore(int x, int y, Rectangle innerAlloc)`
  Determines if a point falls before an allocated region.
  `protected boolean`
  `isLayoutValid(int axis)`
  Determines if the layout is valid along the given axis.
  `void`
  `layoutChanged(int axis)`
  Invalidates the layout along an axis.
  `protected void`
  `layoutMajorAxis(int targetSpan, int axis, int[] offsets, int[] spans)`
  Performs layout for the major axis of the box (i.e. the axis that it represents).
  `protected void`
  `layoutMinorAxis(int targetSpan, int axis, int[] offsets, int[] spans)`
  Performs layout for the minor axis of the box (i.e. the axis orthogonal to the axis that it represents).
  `Shape`
  `modelToView(int pos, Shape a, Position.Bias b)`
  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  `protected void`
  `paintChild(Graphics g, Rectangle alloc, int index)`
  Paints a child.
  `void`
  `preferenceChanged(View child, boolean width, boolean height)`
  This is called by a child to indicate its preferred span has changed.
  `void`
  `replace(int index, int length, View[] elems)`
  Invalidates the layout and resizes the cache of requests/allocations.
  `void`
  `setAxis(int axis)`
  Sets the tile axis property.
  `void`
  `setSize(float width, float height)`
  Sets the size of the view.
  `int`
  `viewToModel(float x, float y, Shape a, Position.Bias[] bias)`
  Provides a mapping from the view coordinate space to the logical coordinate space of the model.

  ### Methods declared in class CompositeView

  `getBottomInset, getInsideAllocation, getLeftInset, getNextEastWestVisualPositionFrom, getNextVisualPositionFrom, getRightInset, getTopInset, getView, getViewAtPosition, getViewCount, getViewIndex, modelToView, setInsets, setParagraphInsets, setParent`
  Modifier and Type
  Method
  Description
  `protected short`
  `getBottomInset()`
  Gets the bottom inset.
  `protected Rectangle`
  `getInsideAllocation(Shape a)`
  Translates the immutable allocation given to the view to a mutable allocation that represents the interior allocation (i.e. the bounds of the given allocation with the top, left, bottom, and right insets removed.
  `protected short`
  `getLeftInset()`
  Gets the left inset.
  `protected int`
  `getNextEastWestVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Returns the next visual position for the cursor, in either the east or west direction.
  `int`
  `getNextVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Provides a way to determine the next visually represented model location that one might place a caret.
  `protected short`
  `getRightInset()`
  Gets the right inset.
  `protected short`
  `getTopInset()`
  Gets the top inset.
  `View`
  `getView(int n)`
  Returns the n-th view in this container.
  `protected View`
  `getViewAtPosition(int pos, Rectangle a)`
  Fetches the child view that represents the given position in the model.
  `int`
  `getViewCount()`
  Returns the number of child views of this view.
  `int`
  `getViewIndex(int pos, Position.Bias b)`
  Returns the child view index representing the given position in the model.
  `Shape`
  `modelToView(int p0, Position.Bias b0, int p1, Position.Bias b1, Shape a)`
  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  `protected void`
  `setInsets(short top, short left, short bottom, short right)`
  Sets the insets for the view.
  `protected void`
  `setParagraphInsets(AttributeSet attr)`
  Sets the insets from the paragraph attributes specified in the given attributes.
  `void`
  `setParent(View parent)`
  Sets the parent of the view.

  ### Methods declared in class View

  `append, breakView, createFragment, forwardUpdateToView, getAttributes, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getGraphics, getParent, getStartOffset, getToolTipText, getViewFactory, getViewIndex, insert, isVisible, modelToView, remove, removeAll, updateChildren, updateLayout, viewToModel`
  Modifier and Type
  Method
  Description
  `void`
  `append(View v)`
  Appends a single child view.
  `View`
  `breakView(int axis, int offset, float pos, float len)`
  Tries to break this view on the given axis.
  `View`
  `createFragment(int p0, int p1)`
  Creates a view that represents a portion of the element.
  `protected void`
  `forwardUpdateToView(View v, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the `DocumentEvent` to the give child view.
  `AttributeSet`
  `getAttributes()`
  Fetches the attributes to use when rendering.
  `int`
  `getBreakWeight(int axis, float pos, float len)`
  Determines how attractive a break opportunity in this view is.
  `Container`
  `getContainer()`
  Fetches the container hosting the view.
  `Document`
  `getDocument()`
  Fetches the model associated with the view.
  `Element`
  `getElement()`
  Fetches the structural portion of the subject that this view is mapped to.
  `int`
  `getEndOffset()`
  Fetches the portion of the model for which this view is responsible.
  `Graphics`
  `getGraphics()`
  Fetch a `Graphics` for rendering.
  `View`
  `getParent()`
  Returns the parent of the view.
  `int`
  `getStartOffset()`
  Fetches the portion of the model for which this view is responsible.
  `String`
  `getToolTipText(float x, float y, Shape allocation)`
  Returns the tooltip text at the specified location.
  `ViewFactory`
  `getViewFactory()`
  Fetches the `ViewFactory` implementation that is feeding the view hierarchy.
  `int`
  `getViewIndex(float x, float y, Shape allocation)`
  Returns the child view index representing the given position in the view.
  `void`
  `insert(int offs, View v)`
  Inserts a single child view.
  `boolean`
  `isVisible()`
  Returns a boolean that indicates whether the view is visible or not.
  `Shape`
  `modelToView(int pos, Shape a)`
  Deprecated.
  `void`
  `remove(int i)`
  Removes one of the children at the given position.
  `void`
  `removeAll()`
  Removes all of the children.
  `protected boolean`
  `updateChildren(DocumentEvent.ElementChange ec, DocumentEvent e, ViewFactory f)`
  Updates the child views in response to receiving notification that the model changed, and there is change record for the element this view is responsible for.
  `protected void`
  `updateLayout(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a)`
  Updates the layout in response to receiving notification of change from the model.
  `int`
  `viewToModel(float x, float y, Shape a)`
  Deprecated.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### firstLineIndent

    protected int firstLineIndent
    Indentation for the first line, from the left inset.

- ## Constructor Details

  - ### ParagraphView

    public ParagraphView(Element elem)
    Constructs a `ParagraphView` for the given element.
    Parameters:
      `elem` - the element that this view is responsible for

- ## Method Details

  - ### setJustification

    protected void setJustification(int j)
    Sets the type of justification.
    Parameters:
      `j` - one of the following values:
      - `StyleConstants.ALIGN_LEFT`
      - `StyleConstants.ALIGN_CENTER`
      - `StyleConstants.ALIGN_RIGHT`

  - ### setLineSpacing

    protected void setLineSpacing(float ls)
    Sets the line spacing.
    Parameters:
      `ls` - the value is a factor of the line height

  - ### setFirstLineIndent

    protected void setFirstLineIndent(float fi)
    Sets the indent on the first line.
    Parameters:
      `fi` - the value in points

  - ### setPropertiesFromAttributes

    protected void setPropertiesFromAttributes()
    Set the cached properties from the attributes.

  - ### getLayoutViewCount

    protected int getLayoutViewCount()
    Returns the number of views that this view is responsible for. The child views of the paragraph are rows which have been used to arrange pieces of the `View`s that represent the child elements. This is the number of views that have been tiled in two dimensions, and should be equivalent to the number of child elements to the element this view is responsible for.
    Returns:
      the number of views that this `ParagraphView` is responsible for

  - ### getLayoutView

    protected View getLayoutView(int index)
    Returns the view at a given `index`. The child views of the paragraph are rows which have been used to arrange pieces of the `Views` that represent the child elements. This methods returns the view responsible for the child element index (prior to breaking). These are the Views that were produced from a factory (to represent the child elements) and used for layout.
    Parameters:
      `index` - the `index` of the desired view
    Returns:
      the view at `index`

  - ### getNextNorthSouthVisualPositionFrom

    protected int getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet) throws BadLocationException
    Returns the next visual position for the cursor, in either the east or west direction. Overridden from `CompositeView`.
    Overrides:
      `getNextNorthSouthVisualPositionFrom` in class `CompositeView`
    Parameters:
      `pos` - position into the model
      `b` - either `Position.Bias.Forward` or `Position.Bias.Backward`
      `a` - the allocated region to render into
      `direction` - either `SwingConstants.NORTH` or `SwingConstants.SOUTH`
      `biasRet` - an array containing the bias that were checked in this method
    Returns:
      the location in the model that represents the next location visual position
    Throws:
      `BadLocationException` - for a bad location within a document model
    See Also:
      - `CompositeView.getNextVisualPositionFrom(int, Position.Bias, Shape, int, Position.Bias[])`

  - ### getClosestPositionTo

    protected int getClosestPositionTo(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet, int rowIndex, int x) throws BadLocationException
    Returns the closest model position to `x`. `rowIndex` gives the index of the view that corresponds that should be looked in.
    Parameters:
      `pos` - position into the model
      `b` - the bias
      `a` - the allocated region to render into
      `direction` - one of the following values:
      - `SwingConstants.NORTH`
      - `SwingConstants.SOUTH`
      `biasRet` - an array containing the bias that were checked in this method
      `rowIndex` - the index of the view
      `x` - the x coordinate of interest
    Returns:
      the closest model position to `x`
    Throws:
      `BadLocationException` - if a bad location is encountered

  - ### flipEastAndWestAtEnds

    protected boolean flipEastAndWestAtEnds(int position, Position.Bias bias)
    Determines in which direction the next view lays. Consider the `View` at index n. Typically the `View`s are laid out from left to right, so that the `View` to the EAST will be at index n + 1, and the `View` to the WEST will be at index n - 1. In certain situations, such as with bidirectional text, it is possible that the `View` to EAST is not at index n + 1, but rather at index n - 1, or that the `View` to the WEST is not at index n - 1, but index n + 1. In this case this method would return true, indicating the `View`s are laid out in descending order.

    This will return true if the text is laid out right to left at position, otherwise false.

    Overrides:
      `flipEastAndWestAtEnds` in class `BoxView`
    Parameters:
      `position` - position into the model
      `bias` - either `Position.Bias.Forward` or `Position.Bias.Backward`
    Returns:
      true if the text is laid out right to left at position, otherwise false.

  - ### getFlowSpan

    public int getFlowSpan(int index)
    Fetches the constraining span to flow against for the given child index.
    Overrides:
      `getFlowSpan` in class `FlowView`
    Parameters:
      `index` - the index of the view being queried
    Returns:
      the constraining span for the given view at `index`
    Since:
      1.3
    See Also:
      - `FlowView.getFlowStart(int)`

  - ### getFlowStart

    public int getFlowStart(int index)
    Fetches the location along the flow axis that the flow span will start at.
    Overrides:
      `getFlowStart` in class `FlowView`
    Parameters:
      `index` - the index of the view being queried
    Returns:
      the location for the given view at `index`
    Since:
      1.3
    See Also:
      - `FlowView.getFlowSpan(int)`

  - ### createRow

    protected View createRow()
    Create a `View` that should be used to hold a a row's worth of children in a flow.
    Specified by:
      `createRow` in class `FlowView`
    Returns:
      the new `View`
    Since:
      1.3

  - ### nextTabStop

    public float nextTabStop(float x, int tabOffset)
    Returns the next tab stop position given a reference position. This view implements the tab coordinate system, and calls `getTabbedSpan` on the logical children in the process of layout to determine the desired span of the children. The logical children can delegate their tab expansion upward to the paragraph which knows how to expand tabs. `LabelView` is an example of a view that delegates its tab expansion needs upward to the paragraph.

    This is implemented to try and locate a `TabSet` in the paragraph element's attribute set. If one can be found, its settings will be used, otherwise a default expansion will be provided. The base location for tab expansion is the left inset from the paragraphs most recent allocation (which is what the layout of the children is based upon).

    Specified by:
      `nextTabStop` in interface `TabExpander`
    Parameters:
      `x` - the X reference position
      `tabOffset` - the position within the text stream that the tab occurred at >= 0
    Returns:
      the trailing end of the tab expansion >= 0
    See Also:
      - `TabSet`
      - `TabStop`
      - `LabelView`

  - ### getTabSet

    protected TabSet getTabSet()
    Gets the `Tabset` to be used in calculating tabs.
    Returns:
      the `TabSet`

  - ### getPartialSize

    protected float getPartialSize(int startOffset, int endOffset)
    Returns the size used by the views between `startOffset` and `endOffset`. This uses `getPartialView` to calculate the size if the child view implements the `TabableView` interface. If a size is needed and a `View` does not implement the `TabableView` interface, the `preferredSpan` will be used.
    Parameters:
      `startOffset` - the starting document offset >= 0
      `endOffset` - the ending document offset >= startOffset
    Returns:
      the size >= 0

  - ### findOffsetToCharactersInString

    protected int findOffsetToCharactersInString(char[] string, int start)
    Finds the next character in the document with a character in `string`, starting at offset `start`. If there are no characters found, -1 will be returned.
    Parameters:
      `string` - the string of characters
      `start` - where to start in the model >= 0
    Returns:
      the document offset, or -1 if no characters found

  - ### getTabBase

    protected float getTabBase()
    Returns where the tabs are calculated from.
    Returns:
      where tabs are calculated from

  - ### paint

    public void paint(Graphics g, Shape a)
    Renders using the given rendering surface and area on that surface. This is implemented to delegate to the superclass after stashing the base coordinate for tab calculations.
    Overrides:
      `paint` in class `BoxView`
    Parameters:
      `g` - the rendering surface to use
      `a` - the allocated region to render into
    See Also:
      - `View.paint(Graphics, Shape)`

  - ### getAlignment

    public float getAlignment(int axis)
    Determines the desired alignment for this view along an axis. This is implemented to give the alignment to the center of the first row along the y axis, and the default along the x axis.
    Overrides:
      `getAlignment` in class `BoxView`
    Parameters:
      `axis` - may be either `View.X_AXIS` or `View.Y_AXIS`
    Returns:
      the desired alignment. This should be a value between 0.0 and 1.0 inclusive, where 0 indicates alignment at the origin and 1.0 indicates alignment to the full span away from the origin. An alignment of 0.5 would be the center of the view.

  - ### breakView

    public View breakView(int axis, float len, Shape a)
    Breaks this view on the given axis at the given length.

    `ParagraphView` instances are breakable along the `Y_AXIS` only, and only if `len` is after the first line.

    Parameters:
      `axis` - may be either `View.X_AXIS` or `View.Y_AXIS`
      `len` - specifies where a potential break is desired along the given axis >= 0
      `a` - the current allocation of the view
    Returns:
      the fragment of the view that represents the given span, if the view can be broken; if the view doesn't support breaking behavior, the view itself is returned
    See Also:
      - `View.breakView(int, int, float, float)`

  - ### getBreakWeight

    public int getBreakWeight(int axis, float len)
    Gets the break weight for a given location.

    `ParagraphView` instances are breakable along the `Y_AXIS` only, and only if `len` is after the first row. If the length is less than one row, a value of `BadBreakWeight` is returned.

    Parameters:
      `axis` - may be either `View.X_AXIS` or `View.Y_AXIS`
      `len` - specifies where a potential break is desired >= 0
    Returns:
      a value indicating the attractiveness of breaking here; either `GoodBreakWeight` or `BadBreakWeight`
    See Also:
      - `View.getBreakWeight(int, float, float)`

  - ### calculateMinorAxisRequirements

    protected SizeRequirements calculateMinorAxisRequirements(int axis, SizeRequirements r)
    Calculate the needs for the paragraph along the minor axis.

    This uses size requirements of the superclass, modified to take into account the non-breakable areas at the adjacent views edges. The minimal size requirements for such views should be no less than the sum of all adjacent fragments.

    If the `axis` parameter is neither `View.X_AXIS` nor `View.Y_AXIS`, `IllegalArgumentException` is thrown. If the `r` parameter is `null,` a new `SizeRequirements` object is created, otherwise the supplied `SizeRequirements` object is returned.

    Overrides:
      `calculateMinorAxisRequirements` in class `FlowView`
    Parameters:
      `axis` - the minor axis
      `r` - the input `SizeRequirements` object
    Returns:
      the new or adjusted `SizeRequirements` object
    Throws:
      `IllegalArgumentException` - if the `axis` parameter is invalid
    See Also:
      - `SizeRequirements`

  - ### changedUpdate

    public void changedUpdate(DocumentEvent changes, Shape a, ViewFactory f)
    Gives notification from the document that attributes were changed in a location that this view is responsible for.
    Overrides:
      `changedUpdate` in class `FlowView`
    Parameters:
      `changes` - the change information from the associated document
      `a` - the current allocation of the view
      `f` - the factory to use to rebuild if the view has children
    See Also:
      - `View.changedUpdate(DocumentEvent, Shape, ViewFactory)`